/*
 *   3D matrices etc.
 */

#ifndef __3D_H__
#define __3D_H__

typedef
struct
{
   int x,y,z;
} point;

typedef
struct
{
   float r11, r12, r13;
   float r21, r22, r23;
   float r31, r32, r33;
   float dx,dy,dz;
} tx;

#define PI       3.141592654
#define TWO_PI   6.2831853
#define PI_BY_4  0.78539816
#define PI_BY_2  1.5707963

extern void set_v_tx(tx *tx, point *p1, point *p2);
extern void set_ball_tx(tx *tx, double xa, double ya, point *p);
extern void tx_point(point *p1, tx *tx, point *p2);

extern double sqrt(double);
extern double sincos(double, double*, double*);

#endif
