#include "3d.h"
#include "x_uif.h"
#include "juggle.h"

#define extern
#include "animate.h"

void
init_ap(anim_pix *ap)
/*{{{  */
{
   int i;
   
   for(i=0; i<2; i++)
      ap->pix_h[i].aw = ap->pix_h[i].ah = 0;

   ap->cur = 0;
   ap->tx  = &ap->tx_h[0];
   ap->pix = &ap->pix_h[0];
}
/*}}}  */

void
fit_pix(pix *bp, int w, int h)
/*{{{  */
{
   w = min(w, MAX_PIX_DIM);
   h = min(h, MAX_PIX_DIM);
   
   if ( (w > bp->aw) || (h > bp->ah) )
   {
      if ( bp->aw != 0 )
         XFreePixmap(xdata.display, bp->pm);
      
      bp->aw = max(bp->aw, w);
      bp->ah = max(bp->ah, h);
      
      bp->pm = XCreatePixmap(xdata.display,
                      xdata.drawWin,
                      bp->aw, bp->ah,
                      xdata.depth);
   
      if (bp->pm <= 0)
         printf("Shit - failed to create pm - code %d\n",bp->pm);
   }
}
/*}}}  */

copy_ap(pix *src, pix *dst)
/*{{{  */
{
   dst->w = src->w;
   dst->h = src->h;
   dst->x = src->x;
   dst->y = src->y;
   
   if ( (src->aw == 0) || (src->w == 0) )
      return;
      
   fit_pix(dst, src->w, src->h);
   
   XCopyArea(xdata.display,
             src->pm,
             dst->pm,
             xdata.ColorGC,
             0, 0, src->w, src->h, 0, 0);
}
/*}}}  */

void
step_ap(anim_pix *ap)
/*{{{  */
{
   int cur = 1 - ap->cur;
   
   ap->cur = cur;
   ap->tx  = &ap->tx_h[cur];
   ap->pix = &ap->pix_h[cur];
}
/*}}}  */

void
display_ap(anim_pix *ap, boolean onacid)
/*{{{  */
{
   int cur = ap->cur;
   int old = 1 - cur;
       
   if ( memcmp( &ap->tx_h[old], &ap->tx_h[cur], sizeof(tx) ) )
   {
      if (onacid) 
         acid_draw_pix(ap->pix);
      else
      {
         undraw_pix(&ap->pix_h[old]);
         
         draw_pix(ap->pix);
      }
   }
}
/*}}}  */
