/* objoctcyl.h - structure values for octagonal cylinder*/

{       "Cylinder", "cyl", /* long and short names */
        "cube",         /* long name of dual */
        16, 24, 10,     /* number of vertices, edges, and faces */
        {               /* vertices (x,y,z) */
                        /* all points must be within radius 1 of the origin */

#define Oct(R,Z) DoOct(R, 2*R/5, Z)
#define DoOct(R1,R2,Z) \
                 {  R2,  R1,  Z }, \
                 {  R1,  R2,  Z }, \
                 {  R1, -R2,  Z }, \
                 {  R2, -R1,  Z }, \
                 { -R2, -R1,  Z }, \
                 { -R1, -R2,  Z }, \
                 { -R1,  R2,  Z }, \
                 { -R2,  R1,  Z }  

               Oct( 80,    0), 
               Oct( 80, -LEG_LENGTH)  
#undef Oct
#undef DoOct
        },
        {       /* faces (numfaces + indexes into vertices) */
                /*  faces must be specified clockwise from the outside */

            8,  0,  1,  2,  3,  4,  5,  6,  7,
            4,  0,  8,  9,  1,
            4,  1,  9, 10,  2,
            4,  2, 10, 11,  3,
            4,  3, 11, 12,  4,
            4,  4, 12, 13,  5,
            4,  5, 13, 14,  6,
            4,  6, 14, 15,  7,
            4,  7, 15,  8,  0,
            8, 15, 14, 13, 12, 11, 10,  9,  8, 
         }
},
