#ifndef __X_UIF_H__
#define __X_UIF_H__

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>

typedef struct {

  XtAppContext appContext;
  
  Display *display;
  int	   screen;
  
  int      depth;
  int      mono;
    
  Widget   topWidget,
           drawArea,
           patternList,
           current,
           detail,
           height,
           dwell,
           warp;
  
  Window   drawWin;

  GC       XorGC;
  GC       RevGC;
  GC       ColorGC;

} XDataType;

extern XDataType xdata;

#define STD_WIDTH  1000
#define STD_HEIGHT 1000
#define STD_WIDTH2  500
#define STD_HEIGHT2 500

#define INIT_WIDTH  500
#define INIT_HEIGHT 500

extern   int      cur_width, cur_height;
extern   short    clubs, fill;

#define  INIT_DS   600
extern   int de,       /* Distance of 'screen' from eye */
             ds,       /* Position of screen (from origin) */
             clip_delta;

#include "3d.h"

extern   tx         view_tx;
extern   point      eye, coi;

#include "polyinfo.h"

extern Polyinfo props[];
extern int      props_size;
extern int      prop_index;

extern void init_graphics(int *argc, char *argv[]);
extern void setup_uif();
extern void show_error(char*, int);
extern void fit_view_to_pattern();

#define set_warp_light()   XtManageChild(xdata.warp)
#define unset_warp_light() XtUnmanageChild(xdata.warp)
#endif
